# coding: utf-8

"""
    Onfido API v3.6

    The Onfido API (v3.6)

    The version of the OpenAPI document: v3.6
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict
from typing import Any, ClassVar, Dict, List, Optional
from onfido.models.us_driving_licence_breakdown_address import UsDrivingLicenceBreakdownAddress
from onfido.models.us_driving_licence_breakdown_document import UsDrivingLicenceBreakdownDocument
from onfido.models.us_driving_licence_breakdown_personal import UsDrivingLicenceBreakdownPersonal
from typing import Optional, Set
from typing_extensions import Self

class UsDrivingLicenceBreakdown(BaseModel):
    """
    UsDrivingLicenceBreakdown
    """ # noqa: E501
    document: Optional[UsDrivingLicenceBreakdownDocument] = None
    address: Optional[UsDrivingLicenceBreakdownAddress] = None
    personal: Optional[UsDrivingLicenceBreakdownPersonal] = None
    additional_properties: Dict[str, Any] = {}
    __properties: ClassVar[List[str]] = ["document", "address", "personal"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UsDrivingLicenceBreakdown from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        * Fields in `self.additional_properties` are added to the output dict.
        """
        excluded_fields: Set[str] = set([
            "additional_properties",
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of document
        if self.document:
            _dict['document'] = self.document.to_dict()
        # override the default output from pydantic by calling `to_dict()` of address
        if self.address:
            _dict['address'] = self.address.to_dict()
        # override the default output from pydantic by calling `to_dict()` of personal
        if self.personal:
            _dict['personal'] = self.personal.to_dict()
        # puts key-value pairs in additional_properties in the top level
        if self.additional_properties is not None:
            for _key, _value in self.additional_properties.items():
                _dict[_key] = _value

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UsDrivingLicenceBreakdown from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "document": UsDrivingLicenceBreakdownDocument.from_dict(obj["document"]) if obj.get("document") is not None else None,
            "address": UsDrivingLicenceBreakdownAddress.from_dict(obj["address"]) if obj.get("address") is not None else None,
            "personal": UsDrivingLicenceBreakdownPersonal.from_dict(obj["personal"]) if obj.get("personal") is not None else None
        })
        # store additional fields in additional_properties
        for _key in obj.keys():
            if _key not in cls.__properties:
                _obj.additional_properties[_key] = obj.get(_key)

        return _obj


